<?php

namespace app\admin\controller;

use app\admin\common\AdminController;
use app\common\api\VerifyApi;
use app\common\api\TalentLogApi;
use app\common\api\TalentState;
use app\enterprise\model\Talent as TalentModel;
use app\common\api\TalentConditionApi;

/**
 * Description of Talent
 *
 * @author sgq
 */
class Talent extends AdminController {

    public function common_check() {
        $request = $this->request;
        $params = $request->param();
        $id = $params["id"];
        $info = VerifyApi::getTalentInfoById($id);
        if ($info["checkState"] == 3) {
            return view("talentInfo_base_check", ["info" => $info]);
        } else {
            return view("talentInfo_common_check", ["info" => $info]);
        }
    }

    public function cancel_verify() {
        $params = $this->request->param();
        $ids = $params["ids"];
        $msg = $params["msg"];
        if ($msg == "") {
            return json(["msg" => "请填写审核不通过的原因"]);
        }
        $ids_arr = array_filter(explode(",", $ids));
        $counts = 0;
        foreach ($ids_arr as $id) {
            $ti = VerifyApi::getOne($id);
            $data["id"] = $id;
            if ($ti["checkState"] == TalentState::FST_SUBMIT) {
                $data["checkState"] = TalentState::BASE_VERIFY_FAIL;
                TalentLogApi::write(1, $id, [TalentState::BASE_VERIFY_FAIL], $msg, 1);
                TalentModel::update($data);
                $counts++;
            } else if ($ti["checkState"] == TalentState::SCND_SAVE) {
                $data["checkState"] = TalentState::FST_VERIFY_FAIL;
                TalentLogApi::write(1, $id, [TalentState::FST_VERIFY_FAIL], $msg, 1);
                TalentModel::update($data);
                $counts++;
            } else {
                //return json(["msg" => "不在审核范围"]);
            }
        }
        return json(["code" => 200, sprintf("%d个申请已审核失败", $counts)]);
    }

    public function base_verify() {
        return view();
    }

    public function base_verify_list() {
        $request = $this->request;
        return json(VerifyApi::getList($request));
    }

    /**
     * 部门初审
     * @auth {{/talentInfo/gotoIndex/-1}}
     */
    public function dept_fst_verify() {
        return view();
    }

    /**
     * 初审
     * @auth {{/talentInfo/gotoIndex/1}}
     */
    public function fst_verify() {
        return view();
    }

    /**
     * 初审-审核
     * @auth {{/talentInfo/firstCheck}}
     */
    public function fst_check() {
        
    }

    /**
     * 初审-修改驳回字段
     * @auth {{/talentInfo/updateFieldsAndFiles}}
     */
    public function updateFieldsAndFiles() {
        
    }

    /**
     * 初审-审核不通过
     * @auth {{/talentInfo/setNotPass}}
     */
    public function dis_pass() {
        
    }

    /**
     * 部门审核
     * @auth {{/talentInfo/gotoIndex/2}}
     */
    public function dept_verify() {
        return view();
    }

    /**
     * 复审
     * @auth {{/talentInfo/gotoIndex/3}}
     */
    public function re_verify() {
        return view();
    }

    /**
     * 复审-撤销复核
     * @auth {{/talentInfo/cancleThirdCheck}}
     */
    public function cancel_check() {
        
    }

    /**
     * 预备人才库
     * @auth {{/talentInfo/gotoIndex/4}}
     */
    public function pre_list() {
        $this->common_verify(4);
    }

    /**
     * 预备人才库-公示
     * @auth {{/talentInfo/preparePublic}}
     */
    public function pre_public() {
        
    }

    /**
     * 预备人才库-核查征信
     * @auth {{/talentInfo/prepareHczx}}
     */
    public function pre_hczx() {
        
    }

    /**
     * 预备人才库-征信通过
     * @auth {{/talentInfo/hczxPass}}
     */
    public function pre_zx_pass() {
        
    }

    /**
     * 预备人才库-征信失信
     * @auth {{/talentInfo/hczxReject}}
     */
    public function pre_zx_reject() {
        
    }

    /**
     * 预备人才库-公示再审核
     * @auth {{/talentInfo/prepareCheck}}
     */
    public function pre_check() {
        
    }

    /**
     * 预备人才库-公示通过
     * @auth {{/talentInfo/publicPass}}
     */
    public function pre_public_pass() {
        
    }

    /**
     * 预备人才库-公布
     * @auth {{/talentInfo/preparePublish}}
     */
    public function pre_publish() {
        
    }

    /**
     * 预备人才库-发证
     * @auth {{/talentInfo/prepareCertification}}
     */
    public function pre_certification() {
        
    }

    /**
     * 预备人才库-撤销公布
     * @auth {{/talentInfo/prepareCanclePublish}}
     */
    public function pre_cancel_publish() {
        
    }

    /**
     * 预备人才库-公示预览
     * @auth {{/talentInfo/publicExportBefore}}
     */
    public function pre_public_preview() {
        
    }

    /**
     * 预备人才库-公布预览
     * @auth {{/talentInfo/publishExportBefore}}
     */
    public function pre_publish_preview() {
        
    }

    /**
     * 基本条件审核-提交未保存
     * @param \think\Request $request
     * @param type $talent_info
     * @return type json
     */
    private function baseCheck(\think\Request $request, $talent_info) {
        $params = $request->param();
        if ($params["checkState"] == 3) {
            //审核成功
            $log_checkState = $checkState = TalentState::BASE_VERIFY_PASS; //初审成功
        } else {
            //审核驳回并记录需要修改的字段和上传文件
            $checkState = TalentState::FST_SAVE; //退回提交材料阶段
            $log_checkState = TalentState::BASE_REJECT; //日志记录拒绝状态
        }
        $log = TalentLogApi::getLastLog($talent_info["id"], 1);
        if (!$log)
            return json(["msg" => "日志数据异常,保存失败"]);
        if ($log["active"] == 0) {
            TalentLogApi::rewrite($log["id"], [$log_checkState, $checkState], $params["checkMsg"]);
        } else {
            TalentLogApi::write(1, $talent_info["id"], [$log_checkState, $checkState], $params["checkMsg"]);
        }
        $data["id"] = $talent_info["id"];
        $data["modify_files"] = $params["files"];
        $data["modify_fields"] = $params["fields"];
        TalentModel::update($data);
        return json(["code" => 200, "msg" => "保存成功"]);
    }

    /**
     * 基本条件审核-提交审核
     * @param type $talent_info
     * @return type json
     */
    private function baseSubmitCheck($talent_info) {
        return $this->commonSubmitCheck($talent_info, 1);
    }

    /**
     * 初审-提交未保存
     * @param \think\Request $request
     * @param type $talent_info
     * @return type json
     */
    private function fstCheck(\think\Request $request, $talent_info) {
        $params = $request->param();
        if ($params["checkState"] == 3) {
            //审核成功
            $log_checkState = $checkState = TalentState::FST_VERIFY_PASS; //初审成功
        } else {
            //审核驳回并记录需要修改的字段和上传文件
            $checkState = TalentState::SCND_SAVE; //退回材料编辑状态
            $log_checkState = TalentState::FST_VERIFY_REJECT; //日志记录拒绝状态
        }
        $log = TalentLogApi::getLastLog($talent_info["id"], 1);
        if (!$log)
            return json(["msg" => "日志数据异常,保存失败"]);
        if ($log["active"] == 0) {
            TalentLogApi::rewrite($log["id"], [$log_checkState, $checkState], $params["checkMsg"]);
        } else {
            TalentLogApi::write(1, $talent_info["id"], [$log_checkState, $checkState], $params["checkMsg"]);
        }
        $data["id"] = $talent_info["id"];
        $data["modify_files"] = $params["files"];
        $data["modify_fields"] = $params["fields"];
        TalentModel::update($data);
        return json(["code" => 200, "msg" => "保存成功"]);
    }

    /**
     * 初审-提交审核
     * @param type $talent_info
     * @return type json
     */
    private function fstSubmitCheck($talent_info) {
        return $this->commonSubmitCheck($talent_info, 2);
    }

    /**
     * 部门审核-提交未保存
     * @param \think\Request $request
     * @param type $talent_info
     * @return type json
     */
    private function deptCheck(\think\Request $request, $talent_info, $companys) {
        $params = $request->param();
        if ($params["checkState"] == 3) {
            //审核成功
            $log_checkState = $checkState = TalentState::DEPT_VERIFY_PASS; //初审成功
        } else {
            //审核驳回并记录需要修改的字段和上传文件
            $checkState = TalentState::SCND_SUBMIT; //退回待初审
            $log_checkState = TalentState::DEPT_VERIFY_REJECT; //日志记录拒绝状态
        }

        $fst_dept_check_time = $talent_info["first_dept_check_time"];
        if (!$fst_dept_check_time) {
            //第一次部门审核
            $data["first_dept_check_time"] = date("Y-m-d H:i:s");
            TalentLogApi::write(1, $talent_info["id"], [$log_checkState, $checkState], $params["checkMsg"]);
        } else {
            $dept_logs = TalentLogApi::getListLogByTime($talent_info["id"], $fst_dept_check_time);
            $tmp_log = null;
            foreach ($dept_logs as $dept_log) {
                if ($dept_log["companyId"] == $this->user["companyId"]) {
                    //检察在第一次部门审核后产生的日志记录中是否存在当前部门记录，有就修改，没有就新增
                    $tmp_log = $dept_log;
                    break;
                }
            }
            if ($tmp_log) {
                //修改
                TalentLogApi::rewrite($tmp_log["id"], [$log_checkState, $checkState], $params["checkMsg"]);
            } else {
                //新增
                TalentLogApi::write(1, $talent_info["id"], [$log_checkState, $checkState], $params["checkMsg"]);
            }
        }
        $data["id"] = $talent_info["id"];
        $data["modify_files"] = $params["files"];
        $data["modify_fields"] = $params["fields"];
        TalentModel::update($data);
        return json(["code" => 200, "msg" => "保存成功"]);
    }

    /**
     * 部门审核-提交审核
     * @param type $talent_info
     * @return type json
     */
    private function deptSubmitCheck($talent_info, $companys) {
        $dept_logs = TalentLogApi::getListLogByTime($talent_info["id"], $talent_info["first_dept_check_time"]);
        $tmp_log = null;
        $succeed = 0;
        foreach ($dept_logs as $dept_log) {
            $succeed += $dept_log["active"] == 1 ? 1 : 0;
            if ($dept_log["companyId"] == $this->user["companyId"]) {
                $tmp_log = $dept_log;
            }
        }
        if (!$tmp_log || $tmp_log["active"] == 1)
            return json(["msg" => "日志数据异常,审核失败"]);
        $refused = false;
        if ($dept_log["new_state"] == TalentState::DEPT_VERIFY_PASS) {
            $succeed++;
            $data["highProcess"] = $nowProcess > $talent_info["highProcess"] ? $nowProcess : $talent_info["highProcess"];
        } else {
            //有一个审核失败就结束
            $refused = true;
        }
        if ($refused || ($succeed == count($companys))) {
            $nowProcess = 1;
            $data["id"] = $talent_info["id"];
            $data["checkState"] = $dept_log["new_state"];
            $data["first_dept_check_time"] = null;
            TalentModel::update($data);
        }
        TalentLogApi::setActive($tmp_log["id"], 1);
        return json(["code" => 200, "msg" => "审核成功"]);
    }

    /**
     * 复审-提交未保存
     * @param \think\Request $request
     * @param type $talent_info
     * @param type json
     */
    private function reCheck(\think\Request $request, $talent_info) {
        $params = $request->param();
        if ($params["checkState"] == 3) {
            //审核成功
            $log_checkState = $checkState = TalentState::REVERIFY_PASS; //复核成功
        } else if ($params["checkState"] == 2) {
            //审核驳回并记录需要修改的字段和上传文件
            $checkState = TalentState::SCND_SUBMIT; //退回待初审
            $log_checkState = TalentState::REVERIFY_REJECT; //日志记录拒绝状态
        } else {
            $log_checkState = $checkState = TalentState::REVERIFY_FAIL; //审核失败
        }
        $log = TalentLogApi::getLastLog($talent_info["id"], 1);
        if (!$log)
            return json(["msg" => "日志数据异常,保存失败"]);
        if ($log["active"] == 0) {
            TalentLogApi::rewrite($log["id"], [$log_checkState, $checkState], $params["checkMsg"]);
        } else {
            TalentLogApi::write(1, $talent_info["id"], [$log_checkState, $checkState], $params["checkMsg"]);
        }
        $data["id"] = $talent_info["id"];
        $data["modify_files"] = $params["files"];
        $data["modify_fields"] = $params["fields"];
        TalentModel::update($data);
        return json(["code" => 200, "msg" => "保存成功"]);
    }

    /**
     * 复审-提交审核
     * @param type $talent_info
     * @return type json
     */
    private function reSubmitCheck($talent_info) {
        return $this->commonSubmitCheck($talent_info, 4);
    }

    private function commonSubmitCheck($talent_info, $nowProcess) {
        $log = TalentLogApi::getLastLog($talent_info["id"], 1);
        if (!$log || $log["active"] == 1)
            return json(["msg" => "日志数据异常,审核失败"]);
        if (in_array($log["checkState"], [TalentState::BASE_VERIFY_PASS, TalentState::FST_VERIFY_PASS, TalentState::REVERIFY_PASS])) {
            $data["highProcess"] = $nowProcess > $talent_info["highProcess"] ? $nowProcess : $talent_info["highProcess"];
        }
        $data["id"] = $talent_info["id"];
        $data["checkState"] = $log["new_state"];
        TalentModel::update($data);
        TalentLogApi::setActive($log["id"], 1);
        return json(["code" => 200, "msg" => "审核成功"]);
    }

    public function check() {
        //公共调度方法
        $request = $this->request;
        $params = $request->param();
        $check = $params["checkState"];
        $check_msg = trim($params["checkMsg"]);
        $files = $params["files"];
        $fields = $params["fields"];
        $id = $params["id"];
        $talent_info = VerifyApi::getOne($id);
        $checkState = $talent_info["checkState"];
        if (!$talent_info) {
            return json(["msg" => "数据错误"]);
        }
        if (!$check) {
            return json(["msg" => "请选择审核状态"]);
        }
        if (!$check_msg) {
            return json(["msg" => "请填写审核说明"]);
        }
        if ($checkState == TalentState::FST_SUBMIT) {
            return $this->baseCheck($request, $talent_info);
        } else if ($checkState == TalentState::SCND_SUBMIT) {
            return $this->fstCheck($request, $talent_info);
        } else if ($checkState == TalentState::FST_VERIFY_PASS) {
            $condition = TalentConditionApi::getOne($talent_info["talent_condition"]);
            $companys = array_filter(impolode(",", $condition["companyIds"]));
            if ($companys) {
                $companyIds = array_filter(explode(",", $companys));
                if (in_array($this->user["companyId"], $companyIds))
                    return json(["msg" => "你的部门不在并审部门列表"]);
                return $this->deptCheck($request, $talent_info, $companyIds);
            } else {
                return $this->reCheck($request, $talent_info);
            }
        } else if ($checkState == TalentState::DEPT_VERIFY_PASS) {
            return $this->reCheck($request, $talent_info);
        } else {
            return json(["msg" => "不在审核范围内，保存失败"]);
        }
    }

    public function submitCheck() {
        //公共调度方法
        $id = $this->request->param("id");
        $talent_info = VerifyApi::getOne($id);
        $checkState = $talent_info["checkState"];
        if (!$talent_info) {
            return json(["msg" => "数据错误"]);
        }
        if ($checkState == TalentState::FST_SUBMIT) {
            return $this->baseSubmitCheck($talent_info);
        } else if ($checkState == TalentState::SCND_SUBMIT) {
            return $this->fstSubmitCheck($talent_info);
        } else if ($checkState == TalentState::FST_VERIFY_PASS) {
            $condition = TalentConditionApi::getOne($talent_info["talent_condition"]);
            $companys = array_filter(impolode(",", $condition["companyIds"]));
            if ($companys) {
                $companyIds = array_filter(explode(",", $companys));
                if (in_array($this->user["companyId"], $companyIds))
                    return json(["msg" => "你的部门不在并审部门列表"]);
                return $this->deptSubmitCheck($talent_info, $companyIds);
            } else {
                return $this->reSubmitCheck($talent_info);
            }
        } else if ($checkState == TalentState::DEPT_VERIFY_PASS) {
            return $this->reSubmitCheck($talent_info);
        } else {
            return json(["msg" => "不在审核范围内，审核失败"]);
        }
    }

    public function validateIsCheck() {
        $params = $this->request->param();
        $id = $params["id"];
        $talent_info = VerifyApi::getOne($id);
        if ($talent_info) {
            $checkState = $talent_info["checkState"];
            // 0正在填写 1保存未提交 2已提交未审核 3已审核 4驳回 5保存补充材料未提交 6提交补充材料进入初审 7初审通过 8初审驳回 9部门审核通过 10部门审核驳回 11复核通过 12复核驳回 13复核失败
            $process = 0;
            if (in_array($checkState, [2, 6, 7, 9])) {
                switch ($checkState) {
                    case 2:
                        $enterprise = \app\common\model\Enterprise::findOrEmpty($talent_info["enterprise_id"]);
                        $fields = \app\common\api\DictApi::getTalentFields(1);
                        $field_tmp = [];
                        foreach ($fields as $key => $field) {
                            $field_tmp[] = ["key" => $key, "value" => $field];
                        }
                        $where[] = ["project", "=", 1];
                        $where[] = ["step", "=", 1];
                        $where[] = ["active", "=", 1];
                        $where[] = ["type", "=", $enterprise["type"]];

                        $files = \think\facade\Db::table("new_common_filetype")->where($where)->select();
                        $process = 1;
                        break;
                    case 6:
                        $process = 2;
                        break;
                    case 7:
                        $fields = \app\common\api\DictApi::getTalentFields(3);
                        $process = 3;
                        break;
                    case 9:
                        $fields = \app\common\api\DictApi::getTalentFields(3);
                        $process = 4;
                        break;
                }
                if ($checkState != 2) {
                    $enterprise = \app\common\model\Enterprise::findOrEmpty($talent_info["enterprise_id"]);
                    $fields = \app\common\api\DictApi::getTalentFields(3);
                    $field_tmp = [];
                    foreach ($fields as $key => $field) {
                        $field_tmp[] = ["key" => $key, "value" => $field];
                    }
                    $where[] = ["project", "=", 1];
                    $where[] = ["active", "=", 1];
                    $where[] = ["type", "=", $enterprise["type"]];

                    $files = \think\facade\Db::table("new_common_filetype")->where($where)->select();
                }
                return json(["code" => 200, "obj" => ["process" => $process, "talentInfo" => $talent_info, "fieldList" => $field_tmp, "fileList" => $files]]);
            } else {
                return json(["msg" => "该申报不在审核范围内，无法审核"]);
            }
        }
    }

}
